function setup(component) {
  var components = document.querySelectorAll('input[name="' + component + '"]')

  chrome.storage.sync.get(component, function(o) {
    if (o && o[component]) {
      for (var i = 0; i < components.length; i++) {
        if (components[i].value === o[component]) {
          components[i].checked = true
          break
        }
      }
    } else {
      var t = {}
      t[component] = components[0].value
      chrome.storage.sync.set(t)
      components[0].checked = true
    }
  })

  function clickHandler(e) {
    var t = {}
    t[this.name] = this.value
    chrome.storage.sync.set(t)
  }

  components.forEach((e) => {
    e.addEventListener('click', clickHandler, !0)
  })

  document.querySelector('.' + component + 'caption').innerText =
    chrome.i18n.getMessage(component + 'Title')
}

setup('engine')
setup('tabmode');

(function() {
  let button = document.querySelector('button');
  button.addEventListener('click', function() {
    let controls = document.querySelector('div[id="controls"]');

    chrome.tabs.query({
      active: true,
      currentWindow: true
    }, function(tabs) {
      if (tabs && tabs.length > 0) {
        var current = tabs[tabs.length - 1]
        let url = current.url;

        if (controls.style.display == 'none') {
          controls.style.display = 'block';
        } else {
          controls.style.display = 'none';
        }

        var o = {};
        o[url] = controls.style.display === 'none';
        chrome.storage.sync.set(o);

        chrome.tabs.executeScript(current.tabId, {
          code: "window['"+url+"']="+o[url],
          allFrames: true,
        })
      }
    });

  });


  chrome.tabs.query({
    active: true,
    currentWindow: true
  }, function(tabs) {
    if (tabs && tabs.length > 0) {
      var current = tabs[tabs.length - 1]
      let url = current.url;

      chrome.storage.sync.get(url, function(o) {
        let controls = document.querySelector('div[id="controls"]');
        if (o && o[url]) {
          controls.style.display = 'none';
          button.innerText = 'Enable on this page'
        } else {
          controls.style.display = 'block';
          button.innerText = 'Disable on this page'
        }
      })
    }
  })
})();
