'use strict';


(function() {

    function dragstart(e) {
      if (window[location.href])
        return false

      var data = ''
      if (window.getSelection() && window.getSelection().anchorNode &&
        window.getSelection().anchorNode.parentNode === e.target.parentNode) {
        data = window.getSelection().toString()
      }
      // data = data || e.target.src || e.target.href || e.target.innerText
      if (!data) {
        data = data || e.target.href || (function(element) {
          while (!element.parentElement.href) {
            element = element.parentElement
          }
          return element.parentElement.href
        })(e.target)
      }
      e.dataTransfer.setData('text/plain', data)
      e.dataTransfer.effectAllowed = 'move'
      return false
    }

    function dragover(e) {
      if (window[location.href])
        return false

      e.preventDefault()
      e.stopPropagation()
      e.dataTransfer.dropEffect = 'move'
      return false
    }

    function drop(e) {
      if (window[location.href])
        return false

      e.preventDefault()
      e.stopPropagation()
      e.dataTransfer.dropEffect = 'move'

      var dropData = (e.dataTransfer.getData('text') === 'undefined' ?
        e.dataTransfer.getData('text/html') :
        e.dataTransfer.getData('text/plain'))
      dropData = dropData.replace(/(<([^>]+)>)/ig, '')

      chrome.runtime.sendMessage({
        c: encodeURIComponent(dropData),
        foreground: e.ctrlKey ? e.ctrlKey : null
      })
      return false
    }

    function DNDHandler(element) {
      if (window[location.href])
        return false

      element.removeEventListener('dragstart', dragstart, true)
      element.addEventListener('dragstart', dragstart, true)
      element.removeEventListener('dragover', dragover, true)
      element.addEventListener('dragover', dragover, true)
      element.removeEventListener('drop', drop, true)
      element.addEventListener('drop', drop, true)
    }

    var li = document.body.children
    for (var i = 0; i < li.length; i++) {
      DNDHandler(li[i])
    }

    document.body.addEventListener('DOMNodeInserted', function(ev) {
      DNDHandler(ev.target)
    }, false)

    let url = location.href
    chrome.storage.sync.get(url, function(o) {
      if (o && o[url]) {
        window[url] = true
      }
    })

})()
